; Zac test ASM program #1
; (c) 2012 Zac
;


; ===========================================================
; Start of the Program
; ===========================================================

; Origin of a ZX81 file is always 16393

                ORG 16393
                
; System variables.

VERSN:          DEFB 0
E_PPC:          DEFW 2
D_FILE:         DEFW Display
DF_CC:          DEFW Display+1                  ; First character of display
VARS:           DEFW Variables
DEST:           DEFW 0
E_LINE:         DEFW BasicEnd 
CH_ADD:         DEFW BasicEnd+4                 ; Simulate SAVE "X"
X_PTR:          DEFW 0
STKBOT:         DEFW BasicEnd+5
STKEND:         DEFW BasicEnd+5                 ; Empty stack
BREG:           DEFB 0
MEM:            DEFW MEMBOT
UNUSED1:        DEFB 0
DF_SZ:          DEFB 2
S_TOP:          DEFW $0002                      ; Top program line number
LAST_K:         DEFW $FDBF
DEBOUN:         DEFB 15
MARGIN:         DEFB 55
NXTLIN:         DEFW Line2                      ; Next line address
OLDPPC:         DEFW 0
FLAGX:          DEFB 0
STRLEN:         DEFW 0
T_ADDR:         DEFW $0C8D
SEED:           DEFW 0
FRAMES:         DEFW $F5A3
COORDS:         DEFW 0
PR_CC:          DEFB $BC
S_POSN:         DEFW $1821
CDFLAG:         DEFB $40
PRBUFF:         DEFB 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,$76 ; 32 Spaces + Newline
MEMBOT:         DEFB 0,0,0,0,0,0,0,0,0,0,$84,$20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; 30 zeros
UNUNSED2:       DEFW 0

; End of system variables

Program:        
Line1:          DEFB $00,$01                    ; Line 1
                DEFW Line1End-Line1Text         ; Line 1 length
Line1Text:      DEFB $EA                        ; REM            
; ABOVE is overhead to create a working program 
   
; ===========================================================
; THIS IS THE CODE FOR A ZX81
; ===========================================================

start	dec b		; 01 B loops through the code
	defb 14		; 02 LD C,13
xloop	dec c		; 03 Hidden DEC C
	jr z,start	; 05 Test end of line and end of triangle

	ld a,b		; 06
	sub 5		; 08
	cp c		; 09 Test a printable position

print	push bc		; 10 Save X and Y, unfortunately needed
	call c,#8f5	; 13 if valid position, compute screenaddress 
	pop bc		; 14 ROM routine kills BC, Retrieve X and Y
	ld a,18		; 16 preset for rotation 
	cp (hl)		; 17 test against current character on screen
	ld (hl),23	; 19 write a star
	jr c,xloop	; 21 A star will give a carry, an empty field not
	
	sub c		; 22
	ld c,b		; 23
	ld b,a		; 24
	scf		; 25 Carry flag needed for next loop
	jr print	; 27 Next print

size equ $-start
	
; BELOW IS CODE NEEDED TO (AUTO)START THE CODE
; AND THE FULL SCREEN IS PART OF EACH ZX81 GAME

; THE BASIC TO START THE CODE

                DEFB $76                        ; Newline
Line1End:       
Line2:          DEFB $00,$02                    ; Line 2
                DEFW Line2End-Line2Text
Line2Text:      DEFB $F9,$D4                    ; RAND USR
                DEFB $1D,$22,$21,$1D,$20        ; 16514
                DEFB $7E                        ; Number
                DEFB $8F,$01,$04,$00,$00        ; Numeric encoding
                DEFB $76                        ; Newline
Line2End: 

Display:        DEFB $76                        ; Newline
		block 32,0
                DEFB $76 ; Line 0
		block 32,0
                DEFB $76 ; Line 1
		block 32,0
                DEFB $76 ; Line 2
		block 32,0
                DEFB $76 ; Line 3
		block 32,0
                DEFB $76 ; Line 4
		block 32,0
                DEFB $76 ; Line 5
		block 32,0
                DEFB $76 ; Line 6
		block 32,0
                DEFB $76 ; Line 7
		block 32,0
                DEFB $76 ; Line 8
		block 32,0
                DEFB $76 ; Line 9 
		block 32,0
                DEFB $76 ; Line 10
		block 32,0
                DEFB $76 ; Line 11
		block 32,0
                DEFB $76 ; Line 12
		block 32,0
                DEFB $76 ; Line 13
		block 32,0
                DEFB $76 ; Line 14
		block 32,0
                DEFB $76 ; Line 15
		block 32,0
                DEFB $76 ; Line 16
		block 32,0
                DEFB $76 ; Line 17
		block 32,0
                DEFB $76 ; Line 18
		block 32,0
                DEFB $76 ; Line 19
		block 32,0
                DEFB $76 ; Line 20
		block 32,0
                DEFB $76 ; Line 21
		block 32,0
                DEFB $76 ; Line 22
		block 32,0
                DEFB $76 ; Line 23

; Variables area (empty)
Variables:      
VariablesEnd:   DEFB $80
BasicEnd:                              
                      